#!/usr/bin/python

# Copyright (C) 2009 Stefano Zacchiroli <zack@pps.jussieu.fr>
# License: GPL version 3 or (at your option) any later version

# add lines mapping packages to the value 0 to .strongdeps files
# rationale: the utility to compute strong deps do not output packages
# which have 0 strong dependencies, but we need them to better join
# between

import os, sys
from subprocess import Popen, PIPE

def read_table(fname):
    d = {}
    for line in open(fname):
        (pkg, val) = line.split()
        d[pkg] = val
    return d

def write_table(d, fname):
    sort = Popen(["sort"], stdin=PIPE, stdout=open(fname, 'w'))
    for (key, val) in d.iteritems():
        sort.stdin.write("%s\t%s\n" % (key, val))
    sort.communicate()

try:
    direct_f = sys.argv[1]
    strong_f = sys.argv[2]
except IndexError:
    print "Usage: %s DIRECT_IMPACT_FILE STRONGDEPS_FILE"
    print "E.g.:  %s foo.direct-impact foo.strongdeps"
    sys.exit(2)

if not os.path.isfile(direct_f) or not os.path.isfile(strong_f):
    print "Missing file(s): %s, %s" % (direct_f, strong_f)
    sys.exit(1)
direct, strong = read_table(direct_f), read_table(strong_f)
for pkg in direct.keys():
    if not strong.has_key(pkg):
        strong[pkg] = '0'
os.rename(strong_f, strong_f + '.bak')
write_table(strong, strong_f)
